// PIO.CPP
//
// Parallel Port Input/Output Object
//
// Strictly sends bytes to and from a Parallel Port
//
// This is a fully independant object which knows nothing about the Transporter Controller
//
// Nov. 24, 1995
//
//

#include <iostream.h>		// Stream support for Debug Info       
#include <conio.h>			// _outp, _inp
 
//#include <dos.h>            // DOS interrupts
//#include <io.h>             // Port IO functions

#include "pio.h"			// PIO Class


#define DEBUG	true


PIO::PIO()
{
	
/*
unsigned int *ptraddr;  // Pointer to location of Port Addresses
unsigned int address;       // Address of Port
int a;
	
	ptraddr=(unsigned int *)0x00000408;
	
	for (a = 0; a < 3; a++)
	{
		//address = *ptraddr;

		if (address == 0)
			cout << "No port found for LPT" << a+1 << endl ;
		else
			cout << "Address assigned to LPT" << a+1 << "is" << hex << address << endl;

		// *ptraddr++;
	}
*/
	if ( 888 )
	{
		myPort = 0x378;		// decimal 888
		myDataPort = myPort;
		myStatusPort = myPort + 1;
		myControlPort = myPort + 2;


		// configure port for input

		_outp( myControlPort, 96);	

#ifdef DEBUG
		cout << "pio: Data    " << myDataPort    << " = " << _inp(myDataPort)    << endl;
		cout << "pio: Status  " << myStatusPort  << " = " << _inp(myStatusPort)  << endl;
		cout << "pio: Control " << myControlPort << " = " << _inp(myControlPort) << endl;
#endif DEBUG		
	}
	else
	{
		myPort = NULL;
		myDataPort = NULL;
		myStatusPort = NULL;
		myControlPort = NULL;

#ifdef DEBUG
		cout << "pio: FATAL ERROR: No Data Inut Port located." << endl;
#endif DEBUG		
	}
}


// 	PIO Member Functions


//*******************************************************************
// Read
//
//		Read a byte from the Data Port
//
//*******************************************************************
int PIO::Read()
{
	return _inp(myStatusPort);
}


//*******************************************************************
// Write
//
//		Send data to port and return status
//
//*******************************************************************
int  PIO::Write( const int data )
{

	return _outp(myDataPort, data);

/*
union REGS	Register;           		// Create CPU registers object

Register.h.ah = 0;
Register.h.al = (unsigned char) data;	// Assign data to register
Register.x.dx = Printer;

#if !defined( DEBUG )
int86(0x17, &Register, &Register);      // Use dos printer interrupt to send data and fetch status
#else
cout << "\nPIO: " << hex << (int) Register.h.al;	// Debug Info
return (0);
#endif


return(Register.h.ah);                 // Returns Port Status in low byte
*/

}

//EOF
