/******************************************************************************
 pio.h

	Parallel Port Input/Output for standard IBM Printer ports

	Created  Nov. 24, 1995		SDM
	Modified February 1, 1999	SDM

	Copyright  1995, 1999 by Seanster <Seanster@BrainImplants.com>
	All rights reserved.

 ******************************************************************************/

#ifndef _PIO_H
#define _PIO_H  	// define this avoid being included more than once

class PIO 			// PIO is a Base Class Object
{

public:
	int			lastData;        // Last sent data
	int			lastStatus;

private:
	unsigned int	myPort;		// LPT
	unsigned int	myDataPort;
	unsigned int	myStatusPort;
	unsigned int	myControlPort;

public:
	PIO();    // Use Printer LPT1: by default

	int  Read( void );	// Get data from port
	int  Write( const int data );	// Send data to port and return status.
	
};

#endif //_PIO_H
